package m1;

import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import java.util.Arrays;
import org.apache.hc.client5.http.classic.HttpClient;
import org.apache.hc.client5.http.impl.classic.CloseableHttpClient;
import org.apache.hc.client5.http.impl.classic.CloseableHttpResponse;
import org.apache.hc.core5.http.ClassicHttpResponse;

public class M1Response implements AutoCloseable {
	protected InputStream inputStream;
	protected HttpClient httpClient;
	protected ClassicHttpResponse httpResponse;
	protected String responseAsString = null;

	public M1Response(CloseableHttpResponse httpResponse, CloseableHttpClient httpClient) throws Exception {
		this.inputStream = httpResponse.getEntity().getContent();
		this.httpClient = httpClient;
		this.httpResponse = httpResponse;
	}

	@Override
	public void close() throws Exception {
		for(Object closeable : Arrays.asList(httpResponse, httpClient, inputStream)) {
			try {
				((AutoCloseable) closeable).close();
			} catch(Exception e) {
				e.printStackTrace();
			}
		}
	}

	public String getString() throws Exception {
		if(this.responseAsString == null) {
			this.responseAsString = new String(this.inputStream.readAllBytes(), StandardCharsets.UTF_8);
		}
		return this.responseAsString;
	}

	// NOTE stream only be read once
	public InputStream getInputStream() {
		return inputStream;
	}
}
